<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 10/24/2004 *
 * ===================                          Last change: 11/14/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : rewrite_functions.php                            *
 * -------------------------------------------------------------------- *
 * Short description : Special functions for rewrite extension          *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Spezielle Funktion fuer rewrite-Erweiterung      *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009, 2010 by Mailer Developer Team                    *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
}

// Rewrite links in HTML for better SEO (ugly part of mx!)
function rewriteLinksInCode ($code) {
	// Skip rewriting for configured modules
	if (isInStringIgnoreCase(getModule(), getConfig('rewrite_skip')) !== false) return $code;

	// Generate target URL
	$target = getConfig('URL') . '/cms/';

	// Convert modules.php?module=...
	foreach (array(getConfig('URL'), '{?URL?}') as $rewrite) {
		$code = str_replace($rewrite . '/modules.php?module=', $target, $code);
	} // END - foreach

	// Do we have an URL linked to mxchange.org?
	if (isInStringIgnoreCase(getConfig('SERVER_URL'), $code)) {
		// Convert URLs from my server
		$code = str_replace('{?URL?}/modules.php?module=', getConfig('SERVER_URL') . '/cms/', $code);

		// Convert URLs from my server
		$code = str_replace(getConfig('URL') . '/modules.php?module=', getConfig('SERVER_URL') . '/cms/', $code);
	} // END - if

	// Strip slashes as above for the main URL
	$target2 = preg_quote($target, '/');

	// Action variable
	$action = $target . '$1/act/';

	// Convert &amp;|&action=...
	$code = preg_replace('/' . $target2 . '(.*)&amp;action=/i', $action, $code);

	// "The same procedure as last variable"... now for &amp;what=
	$what = $target . '$1/wht/';
	$code = preg_replace('/' . $target2 . '(.*)&amp;what=/i', $what, $code);

	// Repair missed &amp;what=??? entries
	while (preg_match("/&amp;what=(.*)\/(.*)\/(.*)/i", $code)) {
		$code = preg_replace("/&amp;what=(.*)\/(.*)\/(.*)/i", "/wht/\$1/\$2/\$3", $code);
	} // END - while

	// Return rewritten code
	return $code;
}

// [EOF]
?>
