<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 06/29/2004 *
 * ===================                          Last change: 08/22/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-add_rallye.php                              *
 * -------------------------------------------------------------------- *
 * Short description : Add new rallye                                   *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Neue Ref-Rallye einfuegen                        *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009, 2010 by Mailer Developer Team                    *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!isAdmin())) {
	die();
}

// Add description as navigation point
addMenuDescription('admin', __FILE__);

if (isFormSent()) {
	// Generate timestamps
	$START = mktime(postRequestParameter('start_hour'), postRequestParameter('start_min'), postRequestParameter('start_sec'), postRequestParameter('start_month'), postRequestParameter('start_day'), postRequestParameter('start_year'));
	$END   = mktime(postRequestParameter('end_hour')  , postRequestParameter('end_min')  , postRequestParameter('end_sec')  , postRequestParameter('end_month')  , postRequestParameter('end_day')  , postRequestParameter('end_year')  );

	// Is there already a rallye running?
	$result = SQL_QUERY_ESC("SELECT id, admin_id FROM `{?_MYSQL_PREFIX?}_rallye_data` WHERE (start_time <= %s AND end_time >= %s) OR (start_time >= %s AND start_time <= %s) LIMIT 1",
		array($START, $START, $START, $END), __FILE__, __LINE__);

	if (SQL_HASZERONUMS($result)) {
		// Ok, start and end time did not overlap
		SQL_QUERY_ESC("INSERT INTO `{?_MYSQL_PREFIX?}_rallye_data` (admin_id, title, descr, template, start_time, end_time, auto_add_new_user, is_active, send_notify)
VALUES ('%s','%s','%s','%s','%s','%s','%s','%s','%s')",
			array(
				getCurrentAdminId(),
				postRequestParameter('title'),
				postRequestParameter('descr'),
				postRequestParameter('template'),
				$START,
				$END,
				postRequestParameter('auto_add'),
				postRequestParameter('active'),
				postRequestParameter('notify'),
			), __FILE__, __LINE__);

		// Load id
		$result = SQL_QUERY_ESC("SELECT `id` FROM `{?_MYSQL_PREFIX?}_rallye_data` WHERE start_time='%s' AND end_time='%s' AND `title`='%s' LIMIT 1",
		array($START, $END, postRequestParameter('title')), __FILE__, __LINE__);
		list($id) = SQL_FETCHROW($result);
		SQL_FREERESULT($result);

		if (!empty($id)) {
			// Reload to prices...
			redirectToUrl('modules.php?module=admin&amp;what=config_rallye_prices&amp;rallye='.$id);
		} else {
			// Problem detected...
			loadTemplate('admin_settings_saved', false, '{--RALLYE_PROBLEM_CREATE--}');
		}
	} else {
		// Free memory
		SQL_FREERESULT($result);

		// Overlapping detected
		loadTemplate('admin_settings_saved', false, '{--RALLYE_OVERLAP_TIMES--}');
	}
}

// Prepare some constants for the template
$content['auto_add_options'] = generateOptionList('/ARRAY/', array('Y','N'), array(getMessage('YES'), getMessage('NO') ));
$content['active_options']   = generateOptionList('/ARRAY/', array('N','Y'), array(getMessage('NO') , getMessage('YES')));
$content['notify_options']   = generateOptionList('/ARRAY/', array('Y','N'), array(getMessage('YES'), getMessage('NO') ));

// Starting day
$content['start_sec']   = addSelectionBox('sec'  , 0              , 'start');
$content['start_min']   = addSelectionBox('min'  , 0              , 'start');
$content['start_hour']  = addSelectionBox('hour' , date('G', time()), 'start');
$content['start_day']   = addSelectionBox('day'  , date('d', time()), 'start');
$content['start_month'] = addSelectionBox('month', date('m', time()), 'start');
$content['start_year']  = addSelectionBox('year' , date('Y', time()), 'start');

// Calcualte ending date
$D = date('d', time() + (getConfig('ONE_DAY') * 7));
$M = date('m', time() + (getConfig('ONE_DAY') * 7));
$Y = date('Y', time() + (getConfig('ONE_DAY') * 7));

// Ending day
$content['end_sec']   = addSelectionBox('sec'  , 0              , 'end');
$content['end_min']   = addSelectionBox('min'  , 0              , 'end');
$content['end_hour']  = addSelectionBox('hour' , date('G', time()), 'end');
$content['end_day']   = addSelectionBox('day'  , $D               , 'end');
$content['end_month'] = addSelectionBox('month', $M               , 'end');
$content['end_year']  = addSelectionBox('year' , $Y               , 'end');

// Transfer (maybe found) templates into constant for the template
$content['templates_selection'] = addReferalRallyeTemplateSelection();

// Load template
loadTemplate('admin_add_rallye', false, $content);

// [EOF]
?>
