<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 07/24/2004 *
 * ===================                          Last change: 08/01/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-list_holiday.php                            *
 * -------------------------------------------------------------------- *
 * Short description : List all holiday requests                        *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Alle Urlaubsschaltungen auflisten                *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009, 2010 by Mailer Developer Team                    *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!isAdmin())) {
	die();
}

// Add description as navigation point
addMenuDescription('admin', __FILE__);

// Start listing holiday requests
$result = SQL_QUERY("SELECT
	h.id, h.userid, h.holiday_start, h.holiday_end, h.comments, d.status, d.last_online
FROM
	`{?_MYSQL_PREFIX?}_user_holidays` AS h
LEFT JOIN
	`{?_MYSQL_PREFIX?}_user_data` AS d
ON
	h.userid=d.userid
ORDER BY
	h.userid ASC", __FILE__, __LINE__);

if (SQL_NUMROWS($result) > 0) {
	// List all holiday requests
	$OUT = ''; $SW = 2;
	while ($content = SQL_FETCHARRAY($result)) {
		// Add three dashes to comment when it is empty
		if (empty($content['comments'])) $content['comments'] = '---';

		// Prepare data for the row template
		$content = array(
			'sw'          => $SW,
			'id'          => $content['id'],
			'userid'      => $content['userid'],
			'start'       => generateDateTime($content['holiday_start'], 3),
			'end'         => generateDateTime($content['holiday_end'], 3),
			'comments'    => wordwrap($content['comments'], 15),
			'status'      => $content['status'],
			'last_online' => generateDateTime($content['last_online'], 3),
		);

		// Load row template and switch color
		$OUT .= loadTemplate('admin_list_holiday_row', true, $content);
		$SW = 3 - $SW;
	} // END - while

	// Free memory
	SQL_FREERESULT($result);

	// Load main template
	loadTemplate('admin_list_holiday', false, $OUT);
} else {
	// No holiday requests found
	loadTemplate('admin_settings_saved', false, '{--HOLIDAY_ADMIN_NOTHING_FOUND--}');
}

// [EOF]
?>
